<?php

/**
 This project has been generated by worker generator
 has been made by fahmi sulaiman
 sulaimanfahmi@gmail.com
 check out my github @dekaulitz
 */

namespace App\Http\Models;

use Carbon\Carbon;
use App\Http\Base\BaseModel;

class LaporanpelumasdetailsModel extends BaseModel
{
    /**
     * table name from database
     */
    protected $table = "laporanpelumas_details";

    /**
     *   alias table for relation issues
     */
    protected $aliasTable = "laporanpelumasdetails";

    /**
     * primary key from table remember eloquent doesnt support composite primary key
     */
    protected $primaryKey = "id";
    /**
     * check the incrementing boolean if the incrementing from database is false then the value is false by default
     */
    // public $incrementing = false;
    /**
     * fillable property for eloquent attribute cast
     */
    protected $fillable = [
        "id", "reportId", "itemId", "saldo_awal", "pemakaian", "saldo_akhir", "namaItem", "deskripsi", "tahun", "bulan"
    ];

    protected $aliasPaging = [
        "namaItem" => "laporanpelumasdetails.namaItem"
    ];

    public function joinRelationItemDetails($alias = "itemdetails")
    {
        $this->getQuery()->leftjoin("laporanpelumas_itemdetails as $alias", "$alias.detailId", "=", "laporanpelumasdetails.id");
        return $this;
    }

    public function joinRelationItemDetailsByMonth($alias = "itemdetails")
    {
        $this->getQuery()->leftjoin("laporanpelumas_itemdetails as $alias", function ($join) use ($alias) {
            $join->on("$alias.tahun", "=", "laporanpelumasdetails.tahun");
            $join->on("$alias.bulan", "=", "laporanpelumasdetails.bulan");
            $join->on("$alias.itemId", "=", "laporanpelumasdetails.itemId");
        });
        return $this;
    }
}
